/*******************************************************************************
*     This file is owned and controlled by Xilinx and must be used             *
*     solely for design, simulation, implementation and creation of            *
*     design files limited to Xilinx devices or technologies. Use              *
*     with non-Xilinx devices or technologies is expressly prohibited          *
*     and immediately terminates your license.                                 *
*                                                                              *
*     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"            *
*     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR                  *
*     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION          *
*     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION              *
*     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS                *
*     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,                  *
*     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE         *
*     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY                 *
*     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE                  *
*     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR           *
*     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF          *
*     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS          *
*     FOR A PARTICULAR PURPOSE.                                                *
*                                                                              *
*     Xilinx products are not intended for use in life support                 *
*     appliances, devices, or systems. Use in such applications are            *
*     expressly prohibited.                                                    *
*                                                                              *
*     (c) Copyright 1995-2004 Xilinx, Inc.                                     *
*     All rights reserved.                                                     *
*******************************************************************************/
// The synopsys directives "translate_off/translate_on" specified below are
// supported by XST, FPGA Compiler II, Mentor Graphics and Synplicity synthesis
// tools. Ensure they are correct for your synthesis tool(s).

// You must compile the wrapper file fft_2048.v when simulating
// the core, fft_2048. When compiling the wrapper file, be sure to
// reference the XilinxCoreLib Verilog simulation library. For detailed
// instructions, please refer to the "CORE Generator Guide".

module fft_2048 (
	xn_re,
	xn_im,
	start,
	unload,
	nfft,
	nfft_we,
	fwd_inv,
	fwd_inv_we,
	scale_sch,
	scale_sch_we,
	sclr,
	clk,
	xk_re,
	xk_im,
	xn_index,
	xk_index,
	rfd,
	busy,
	dv,
	edone,
	done);    // synthesis black_box

input [15 : 0] xn_re;
input [15 : 0] xn_im;
input start;
input unload;
input [4 : 0] nfft;
input nfft_we;
input fwd_inv;
input fwd_inv_we;
input [11 : 0] scale_sch;
input scale_sch_we;
input sclr;
input clk;
output [15 : 0] xk_re;
output [15 : 0] xk_im;
output [10 : 0] xn_index;
output [10 : 0] xk_index;
output rfd;
output busy;
output dv;
output edone;
output done;

// synopsys translate_off

	XFFT_V3_1 #(
		1,	// c_arch
		1,	// c_bram_stages
		1,	// c_data_mem_type
		0,	// c_enable_rlocs
		"virtex2",	// c_family
		0,	// c_has_bfp
		1,	// c_has_bypass
		0,	// c_has_ce
		0,	// c_has_natural_output
		1,	// c_has_nfft
		0,	// c_has_ovflo
		1,	// c_has_rounding
		1,	// c_has_scaling
		1,	// c_has_sclr
		16,	// c_input_width
		11,	// c_nfft_max
		0,	// c_optimize
		16,	// c_output_width
		1,	// c_twiddle_mem_type
		16)	// c_twiddle_width
	inst (
		.XN_RE(xn_re),
		.XN_IM(xn_im),
		.START(start),
		.UNLOAD(unload),
		.NFFT(nfft),
		.NFFT_WE(nfft_we),
		.FWD_INV(fwd_inv),
		.FWD_INV_WE(fwd_inv_we),
		.SCALE_SCH(scale_sch),
		.SCALE_SCH_WE(scale_sch_we),
		.SCLR(sclr),
		.CLK(clk),
		.XK_RE(xk_re),
		.XK_IM(xk_im),
		.XN_INDEX(xn_index),
		.XK_INDEX(xk_index),
		.RFD(rfd),
		.BUSY(busy),
		.DV(dv),
		.EDONE(edone),
		.DONE(done),
		.CE(),
		.BLK_EXP(),
		.OVFLO());


// synopsys translate_on

// FPGA Express black box declaration
// synopsys attribute fpga_dont_touch "true"
// synthesis attribute fpga_dont_touch of fft_2048 is "true"

// XST black box declaration
// box_type "black_box"
// synthesis attribute box_type of fft_2048 is "black_box"

endmodule

