/*******************************************************************************
*     This file is owned and controlled by Xilinx and must be used             *
*     solely for design, simulation, implementation and creation of            *
*     design files limited to Xilinx devices or technologies. Use              *
*     with non-Xilinx devices or technologies is expressly prohibited          *
*     and immediately terminates your license.                                 *
*                                                                              *
*     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"            *
*     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR                  *
*     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION          *
*     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION              *
*     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS                *
*     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,                  *
*     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE         *
*     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY                 *
*     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE                  *
*     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR           *
*     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF          *
*     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS          *
*     FOR A PARTICULAR PURPOSE.                                                *
*                                                                              *
*     Xilinx products are not intended for use in life support                 *
*     appliances, devices, or systems. Use in such applications are            *
*     expressly prohibited.                                                    *
*                                                                              *
*     (c) Copyright 1995-2004 Xilinx, Inc.                                     *
*     All rights reserved.                                                     *
*******************************************************************************/
// The synopsys directives "translate_off/translate_on" specified below are
// supported by XST, FPGA Compiler II, Mentor Graphics and Synplicity synthesis
// tools. Ensure they are correct for your synthesis tool(s).

// You must compile the wrapper file sinusoid.v when simulating
// the core, sinusoid. When compiling the wrapper file, be sure to
// reference the XilinxCoreLib Verilog simulation library. For detailed
// instructions, please refer to the "CORE Generator Guide".

module sinusoid (
	THETA,
	CLK,
	SCLR,
	COSINE);    // synthesis black_box

input [9 : 0] THETA;
input CLK;
input SCLR;
output [15 : 0] COSINE;

// synopsys translate_off

	C_SIN_COS_V5_0 #(
		0,	// c_enable_rlocs
		0,	// c_has_aclr
		0,	// c_has_ce
		1,	// c_has_clk
		0,	// c_has_nd
		0,	// c_has_rdy
		0,	// c_has_rfd
		1,	// c_has_sclr
		2,	// c_latency
		0,	// c_mem_type
		0,	// c_negative_cosine
		0,	// c_negative_sine
		1,	// c_outputs_required
		16,	// c_output_width
		0,	// c_pipe_stages
		1,	// c_reg_input
		1,	// c_reg_output
		1,	// c_symmetric
		10)	// c_theta_width
	inst (
		.THETA(THETA),
		.CLK(CLK),
		.SCLR(SCLR),
		.COSINE(COSINE),
		.ND(),
		.CE(),
		.ACLR(),
		.SINE(),
		.RFD(),
		.RDY());


// synopsys translate_on

// FPGA Express black box declaration
// synopsys attribute fpga_dont_touch "true"
// synthesis attribute fpga_dont_touch of sinusoid is "true"

// XST black box declaration
// box_type "black_box"
// synthesis attribute box_type of sinusoid is "black_box"

endmodule

