-- W:\ECE532\MULTIPLIER
-- VHDL Test Bench created by
-- HDL Bencher 6.1i
-- Wed Feb 09 13:27:35 2005
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.NUMERIC_STD.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY multiply_tbench IS
END multiply_tbench;

ARCHITECTURE testbench_arch OF multiply_tbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT multiply
		PORT (
			clk : In  std_logic;
			reset_b : In  std_logic;
			mer : In  std_logic_vector (15 DOWNTO 0);
			mand : In  std_logic_vector (15 DOWNTO 0);
			go : In  std_logic;
			product : Out  std_logic_vector (31 DOWNTO 0);
			done : Out  std_logic
		);
	END COMPONENT;

	SIGNAL clk : std_logic;
	SIGNAL reset_b : std_logic;
	SIGNAL mer : std_logic_vector (15 DOWNTO 0);
	SIGNAL mand : std_logic_vector (15 DOWNTO 0);
	SIGNAL go : std_logic;
	SIGNAL product : std_logic_vector (31 DOWNTO 0);
	SIGNAL done : std_logic;

BEGIN
	UUT : multiply
	PORT MAP (
		clk => clk,
		reset_b => reset_b,
		mer => mer,
		mand => mand,
		go => go,
		product => product,
		done => done
	);

	PROCESS -- clock process for clk,
	BEGIN
		CLOCK_LOOP : LOOP
		clk <= transport '0';
		WAIT FOR 10 ns;
		clk <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 40 ns;
		clk <= transport '0';
		WAIT FOR 40 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS   -- Process for clk
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_product(
			next_product : std_logic_vector (31 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (product /= next_product) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns product="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, product);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_product);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_done(
			next_done : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (done /= next_done) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns done="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, done);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_done);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		reset_b <= transport '0';
		mer <= transport std_logic_vector'("0000000010100101"); --A5
		mand <= transport std_logic_vector'("0000000010100101"); --A5
		go <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=100 ns
		reset_b <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=200 ns
		reset_b <= transport '1';
		go <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=300 ns
		reset_b <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=400 ns
		reset_b <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=500 ns
		go <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=600 ns
		mer <= transport std_logic_vector'("0000000000000000"); --0
		-- --------------------
		WAIT FOR 100 ns; -- Time=700 ns
		reset_b <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=800 ns
		go <= transport '1';
		-- --------------------
		WAIT FOR 200 ns; -- Time=1000 ns
		mer <= transport std_logic_vector'("0000000000000011"); --3
		mand <= transport std_logic_vector'("0000000000000000"); --0
		-- --------------------
		WAIT FOR 100 ns; -- Time=1100 ns
		reset_b <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=1200 ns
		reset_b <= transport '1';
		-- --------------------
		WAIT FOR 200 ns; -- Time=1400 ns
		go <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=1500 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			STD.TEXTIO.write(TX_OUT,string'("No errors or warnings"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			STD.TEXTIO.write(TX_OUT, TX_ERROR);
			STD.TEXTIO.write(TX_OUT, string'(
				" errors found in simulation"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION multiply_cfg OF multiply_tbench IS
	FOR testbench_arch
	END FOR;
END multiply_cfg;
