#include "xparameters.h"
#include "xbasic_types.h"   /* Xilinx basic types for device drivers        */
#include "xac97.h"
#include "mb_interface.h"
#include "xintc.h"

#define TRUE 1
#define FALSE 0
#define printf xil_printf

int playback;
Xuint16 left[16];
Xuint16 right[16];
XAC97 ac97;
XIntc InterruptController;
void fifo_handler(void *CallBackRef);

int main (void) 
{
 	XStatus Status;
	int i;
	
	printf("starting");

/*disable the master interrupts on the interrupt controller*/
XIntc_Out32((XPAR_INTC_SINGLE_BASEADDR) + XIN_MER_OFFSET, 0)


 	init_sound (22000);
// 	printf("completed initialization");
	playback_enable();
//	printf("playback enable");

//	printf("record enable");


//#################Initialization of AC97 Interrupt Handler#################
  /* Initialize the ac97 handler so that it's ready to use,
     * specify the device ID that is generated in xparameters.h
     */
    Status = XAC97_Initialize(&ac97, XPAR_OPB_AC97_CONTROLLER_0_DEVICE_ID);

    if (Status != XST_SUCCESS)
    {
        printf("ac97 handler initialization error\n\r\r");
    }

    /* Perform a self-test to ensure that the hardware was built
     * correctly, use the 1st timer in the device (0)
     */
    Status = XAC97_SelfTest(&ac97);
    if (Status != XST_SUCCESS)
    {
        printf("ac97 handler self-test error\n\r");
    }
	printf("test");
//	XAC97_InterruptHandler(&ac97);
//	printf("handler");
	XAC97_SetHandler(&ac97, &fifo_handler, &ac97);
	printf("handler enable");
	
	record_intr_disable();
//	printf("playback interrupt off");
	

//##########################################################################

//#################Initialization of Interrupt Controller###################
    /*
     * Initialize the interrupt controller driver so that it's ready to use,
     * using the device ID that is generated in xparameters.h
     */
    Status = XIntc_Initialize(&InterruptController, XPAR_OPB_INTC_0_DEVICE_ID);
    if (Status != XST_SUCCESS)
    {
        printf("Interrupt controller initialization error\n\r");
    }
	printf("interrupt enable");
    /*
     * Connect the device driver handler that will be called when an interrupt
     * for the device occurs, the device driver handler performs the specific
     * interrupt processing for the device
     */
    Status = XIntc_Connect(&InterruptController,
                           XPAR_OPB_INTC_0_OPB_AC97_CONTROLLER_0_RECORD_INTERRUPT_INTR,
                           (XInterruptHandler)fifo_handler,
                           &ac97);
    if (Status != XST_SUCCESS)
    {
        printf("Interrupt controller connect error\n\r");
    }
	printf("controller enable");
    /*
     * Start the interrupt controller so interrupts are enabled for all
     * devices that cause interrupts. Specify real mode so that the timer
     * counter can cause interrupts through the interrupt controller.
     */
    Status = XIntc_Start(&InterruptController, XIN_REAL_MODE);
    if (Status != XST_SUCCESS)
    {
        printf("Interrupt controller start error\n\r");
    }
	printf("controller start");

    /* Enable the interrupt for the ac97 and enable interrupts in
     * the microblaze processor
     */
	 	record_fifo_clear();

	    microblaze_enable_interrupts();
	printf("blaze interrupts on");

	record_fifo_clear();
	record_intr_enable();
	printf("record interrupt enable");

    XIntc_Enable(&InterruptController,XPAR_OPB_INTC_0_OPB_AC97_CONTROLLER_0_RECORD_INTERRUPT_INTR);
	printf("xintc interrupts on");

//##########################################################################
printf("initialized");

	record_enable();
 	while (1) 
	{
//	if (playback==1)
//	{
		//left[0]=opb_read_recordfifo();
		//right[0]=opb_read_recordfifo();
//		microblaze_bwrite_datafsl(0, 0);
//		microblaze_bwrite_datafsl(65000, 0);

printf("main");

	for (i=0;i++;i<17){
		microblaze_bwrite_datafsl(left[i], 0);
		microblaze_bwrite_datafsl(right[i], 0);
		}
	record_intr_enable();
//	}
//	printf("running");

 	}
 
}


/**********************/
void fifo_handler(void *CallBackRef)
{
	int i;
	record_intr_disable();
	record_fifo_clear();
	microblaze_disable_interrupts();
//	XIntc_Acknowledge(&InterruptController, XPAR_OPB_AC97_CONTROLLER_0_DEVICE_ID);
XIntc_Disable(&InterruptController, XPAR_OPB_AC97_CONTROLLER_0_DEVICE_ID);
//printf("going now");
if (playback==1)
playback=0;
else
playback=1;

	printf("FUCK");
	for (i=0;i++;i<17)
		{
		left[i]=opb_read_recordfifo();
		right[i]=opb_read_recordfifo();
		}


//	printf("recorded");




//	for (i=0;i++;i<17){
//		microblaze_bwrite_datafsl(left[i], 0);
//		microblaze_bwrite_datafsl(right[i], 0);
//		}

}