#include "xparameters.h"
#include "xbasic_types.h"   /* Xilinx basic types for device drivers        */
#include "xac97.h"
#include "xac97_l.h"
#include "xac97_i.h"
#include "mb_interface.h"

#define TRUE 1
#define FALSE 0
#define printf xil_printf

//Xuint32 storesound[1000];
#define XFFT_mWrite32(Base, Offset, Value) \
		XIo_Out32(((XIo_Address)((Base)+(Offset))),(Value))

// Performs a general 32-bit read operation from specified address
#define XFFT_mRead32(Base, Offset) \
		XIo_In32((XIo_Address)((Base)+Offset))

// Performs a general 16-bit write operation to specified address
#define XFFT_mWrite16(Base, Offset, Value) \
		XIo_Out16(((XIo_Address)((Base)+(Offset))),(Value))

// Performs a general 16-bit read operation from specified address
#define XFFT_mRead16(Base, Offset) \
		XIo_In16((XIo_Address)((Base)+Offset))

#define FORWARD64 0x30011111 //00110000000000011111111111111111
#define INVERSE64 0x30001111 //00110000000000001111111111111111
#define XPAR_FFT_CONTROLLER_0_BASEADDR 0x80060000

#define SIZE 64
	Xuint16 left[SIZE];
	Xuint16 right[SIZE];
	Xuint32 fftdata[SIZE];

int main (void) 
{
 	XStatus Status;
 	Xuint16 soundbyte;
 	Xuint32 temp;
 	int i;

	printf("starting");
 	temp = 0;
 	printf("hello");
 	init_sound (22000);
 	printf("completed initialization");
	playback_enable();
	printf("completed playback enable");
	record_enable();
	printf("completed record enable");
//for (i=0;i<5;i++){
//	printf("delay");
//}

 	while (1) 
	{
//read in audio data
		for (i=0;i<SIZE;i++){
			microblaze_bread_datafsl(left[i], 0);
			microblaze_bread_datafsl(right[i], 0);
		}

//write to FFT core
	for (i=0; i<SIZE; i++){
		microblaze_bwrite_datafsl(left[i], 1);//REPLACE, send 32-bit
	}
//signal FFT to start
	XFFT_mWrite32(XPAR_FFT_CONTROLLER_0_BASEADDR, 0, FORWARD64);
//blocking read of FIFO, the fft will write data faster than mblaze can read fsl
	for (i=0; i<SIZE; i++){
		microblaze_bread_datafsl(fftdata[i], 1);
	}//finished FFT

//write to FFT core, IFFT
	for (i=0; i<SIZE; i++){
		microblaze_bwrite_datafsl(fftdata[i], 1);//REPLACE, send 32-bit
	}
//signal FFT to start
	XFFT_mWrite32(XPAR_FFT_CONTROLLER_0_BASEADDR, 0, INVERSE64);
//blocking read of FIFO, the fft will write data faster than mblaze can read fsl
	for (i=0; i<SIZE; i++){
		microblaze_bread_datafsl(left[i], 1);
	}//finished IFFT

for (i=0;i<SIZE;i++)//turn off right channel
	right[i]=0;

//write out audio data to AC97
		for (i=0;i<SIZE;i++){
			microblaze_bwrite_datafsl(left[i], 0);
			microblaze_bwrite_datafsl(right[i], 0);
		}
 	}
 
}