-------------------------------------------------------------------------------
-- Copyright (c) 1999-2002 Xilinx Inc.  All rights reserved.
-------------------------------------------------------------------------------
-- Title      : ICON Pro Core Xilinx XST Usage Example
-- Project    : ChipScope
-------------------------------------------------------------------------------
-- File       : icon_xst_example.vhd
-- Company    : Xilinx Inc.
-- Created    : 2002/03/27
-------------------------------------------------------------------------------
-- Description: Example of how to instantiate the ICON Pro core in a VHDL 
--              design for use with the Xilinx XST synthesis tool.
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

entity icon_xst_example is
end icon_xst_example;

architecture structure of icon_xst_example is


  -------------------------------------------------------------------
  --
  --  ICON Pro core component declaration
  --
  -------------------------------------------------------------------
  component icon
    port
    (
      tdi_in      : in    std_logic;
      reset_in    : in    std_logic;
      shift_in    : in    std_logic;
      update_in   : in    std_logic;
      sel_in      : in    std_logic;
      drck_in     : in    std_logic;
      tdo_out     :   out std_logic;
      control0    :   out std_logic_vector(35 downto 0)
    );
  end component;


  -------------------------------------------------------------------
  --
  --  ICON Pro core signal declarations
  --
  -------------------------------------------------------------------
  signal tdi_in         : std_logic;
  signal reset_in       : std_logic;
  signal shift_in       : std_logic;
  signal update_in      : std_logic;
  signal sel_in         : std_logic;
  signal drck_in        : std_logic;
  signal tdo_out        : std_logic;
  signal control0       : std_logic_vector(35 downto 0);

begin

  
  -------------------------------------------------------------------
  --
  --  ICON Pro core instance
  --
  -------------------------------------------------------------------
  i_icon : icon
    port map
    (
      tdi_in     => tdi_in,
      reset_in   => reset_in,
      shift_in   => shift_in,
      update_in  => update_in,
      sel_in     => sel_in,
      drck_in    => drck_in,
      tdo_out    => tdo_out,
      control0   => control0
    );


end structure;

